/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.dao;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.HibernateUtilsFactory;
import it.eng.spago4q.HibernateUtilsInterface;

import org.apache.log4j.Logger;
import org.hibernate.Session;

public class AbstractHibernateDAO {

	private static transient Logger logger = Logger
			.getLogger(AbstractHibernateDAO.class);

	public Session getCurrentSession() {
		Session mySession = null;
		ConfigSingleton configSingleton = ConfigSingleton.getInstance();
		SourceBean hibernateUtilsClassSB = (SourceBean) configSingleton
				.getAttribute("SPAGO4Q.HIBERNATE-UTILS-CONF");
		if (hibernateUtilsClassSB != null) {
			String hibernateUtilsClass = hibernateUtilsClassSB.getCharacters();
			hibernateUtilsClass = hibernateUtilsClass.trim();
			try {
				HibernateUtilsInterface hibernateUtils = null;
				hibernateUtils = HibernateUtilsFactory
						.getHibernateUtils(hibernateUtilsClass);
				mySession = hibernateUtils.getCurrentSession();
			} catch (EMFUserError e) {
				logException(e);
			}
		}
		return mySession;
	}

	/**
	 * Traces the exception information of a throwable input object.
	 * 
	 * @param t
	 *            The input throwable object
	 */
	public void logException(final Throwable t) {
		logger.error(t.getClass().getName() + " " + t.getMessage(), t);
	}
}
