/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.exporter;

import it.eng.spago4q.metadata.S4qEDataSource;
import it.eng.spago4q.metadata.S4qESourceType;

import com.thoughtworks.xstream.converters.basic.AbstractSingleValueConverter;

public class DataSourceConverter extends AbstractSingleValueConverter {

	@Override
	public boolean canConvert(final Class clazz) {
		return clazz.equals(S4qEDataSource.class);
	}

	@Override
	public Object fromString(final String str) {
		S4qEDataSource toReturn = new S4qEDataSource();
		toReturn.setS4qESourceType(new S4qESourceType());
		String[] fields = str.split("-");
		if (fields.length == 2) {
			toReturn.setName(fields[0]);
			toReturn.getS4qESourceType().setName(fields[1]);
		} else {
			toReturn.setName(str);
		}
		return toReturn;
	}
}